/* ----------------------------------------------------------------------- */
/*                                                                         */
/*  Projekt  : GetDate.c                                                   */
/*  Autor    : Dipl.-Ing. Markus Robert Keler                             */
/*  Erstellt : 17.05.2007                                                  */
/*  Copyright: (C) 2007 http://www.dipl-ing-kessler.de                     */
/*                                                                         */
/*  Alle Rechte vorbehalten.    Vervielfltigung des Quelltextes verboten. */
/*                                                                         */
/* ----------------------------------------------------------------------- */
/*                                                                         */
/*  Verwendung : Liest Datum und Uhrzeit der per Kommandozeile angegebenen */
/*               Dateien aus dem Dateisystem aus und bringt diese in das   */
/*               fr den UNIX-Befehl touch -t verwertbare Format.          */
/*               Dimke GetDate ist das komplementaere Gegenstuck zu        */
/*               Dimke SetDate.                                            */
/*  Anmerkung :  Dimke GetDate laeuft nur unter DJGPP Bash.                */
/*               Keine Haftung fuer Fehlfunktion bei Einsatz unter m$ DOS! */
/*                                                                         */
/* ----------------------------------------------------------------------- */

#include <stdio.h>
#include <time.h>
#include <io.h>
#include <dos.h>

int main( int argc, char **argv ) {
    int i;
    FILE *stream;
    struct ftime ft;

    if ( argc==1 ) {
        fprintf(stderr,"Dimke getdate - Parameterformat falsch.\n");
        fprintf(stderr,"Aufruf: getdate Datei(en)\nNOT OK.\n");
        exit(-1);
    }

    for ( i=1 ; i<argc ; i++ ) {
        if ((stream = fopen( argv[i] , "r")) == NULL) {
            fprintf ( stderr , "Dimke getdate - Fataler Fehler.\n" );
            fprintf ( stderr , "%s nicht gefunden - Abbruch.\n" , argv[i] );
            fprintf ( stderr , "NOT OK.\n" );
            exit (-1);
        }
        getftime(fileno(stream), &ft);
        fclose(stream);
    
        fprintf ( stdout , "%04d%02d%02d%02d%02d.%02d %s\n" ,
                 ft.ft_year+1980 ,
                 ft.ft_month ,
                 ft.ft_day ,
                 ft.ft_hour ,
                 ft.ft_min ,
                 ft.ft_tsec * 2 ,
                 argv[i]
            );
    }

    return 0;
}
